<template>
    <div id="switcher-super">
        <Inprototype />
        <div id="ss-nav-switcher" @click="onSwitcher">
            <div id="switcher-info">
                <img :src="`${base}avatars/${section.icon}.png`" alt="GitLab">
                {{ section.label }}
            </div>
            <Icon v-if="isSwitcherOpen" icon="chevron-up" color="C-737278" />
            <Icon v-else icon="chevron-down" color="C-737278" />
        </div>
        <div id="ss-switcher-list" v-if="isSwitcherOpen">
            <div id="ss-switcher-search">
                <Icon icon='search' color="C-737278" />
                <input type="text" id="switcher-input" name="search" placeholder="Search for projects or groups">
            </div>
            <div id="ss-content">

                <div id="ss-colum1">
                    <div id="switchto-label">Switch to...</div>
                    <div class="switchto-item" @click="onYourwork">
                        <Icon icon='work' color="C-737278" />
                        <p class="switchto-item-label">Your work</p>
                    </div>
                    <div class="switchto-item" @click="onExplore">
                        <Icon icon='compass' color="C-737278" />
                        <p class="switchto-item-label">Explore</p>
                    </div>
                    <div id="ss-org-list">
                        <div id="switchto-label">Organizations</div>
                        <SwitcherItem v-for="item in orglist.current" :label=item.nav.title :icon=item.nav.icon :url=item.nav.url
                            :section=item.section />
                        <SwitcherItem v-for="item in orglist.list" :label=item.nav.title :icon=item.nav.icon :url=item.nav.url
                            :section=item.section />
                    </div>
                </div>
    
                <div id="ss-colum2">
                        <p class="switchsection-label">FREQUENT PROJECTS</p>
                        <div id="ss-recent">
                            <SwitcherItem v-for="item in user.switcher.projects" :label=item.label :desc=item.desc :icon=item.icon
                                :url=item.url :section=item.section />
                        </div>
                </div>

            </div>

        </div>
        <div id="ss-outside" v-if="isSwitcherOpen" @click="onSwitcher"></div>
    </div>
</template>

<script setup>
import { useMainStore } from '~~/stores/main';
import { storeToRefs } from 'pinia';
import { ref } from 'vue';

const main = useMainStore();
const { section, isSwitcherOpen, base } = storeToRefs(main);
const { setSwitcherOpen, onNavigate } = main;

const { data: orgdata } = await useAsyncData('org', () => queryContent(`/comp/org`).findOne())

const props = defineProps({
    user: {
        type: Object,
        required: false,
        default: {}
    }
});

const count = computed((icon, user) => {
    let n = null
    return n
});

function onSwitcher() {
    if (isSwitcherOpen.value === true) {
        setSwitcherOpen(false)
    } else {
        orgmodal.value = false;
        setSwitcherOpen(true)
    }
}

function onYourwork() {
    setSwitcherOpen(false);
    let dest = {}
    dest.url = `${section.value.org}-yourwork-projects`
    dest.section = {
        org: section.value.org,
        id: 'yourwork',
        label: 'Your work',
        icon: 'yourwork'
    }
    onNavigate(dest);
}

function onNav(sec) {
    orgmodal.value = false;
    setSwitcherOpen(false);
    let dest = {}
    dest.url = `${sec.org}-org-overview`
    dest.section = sec
    onNavigate(dest);
}

function onExplore() {
    //TODO
    let dest = {}
    //onNavigate(dest);
}

const orglist = computed(() => {
    let content = {
        current: {},
        list: {}
    };
    try {
        let matter = orgdata.value.orgs;
        for (const [key, value] of Object.entries(matter)) {
            if (matter[key].section.org === section.value.org) {
                content.current[key] = matter[key]
            } else {
                content.list[key] = matter[key]
            }
        }
    } catch (error) {
        console.log("Org switcher error", section.org);
    }
    return content
});

// Org slide
const orgmodal = ref(false);

const toggleOrgModal = () => {
    if (orgmodal.value) {
        orgmodal.value = false;
    } else {
        orgmodal.value = true;
    }
}


</script>

<style>
#ss-content {
    display: flex;
    padding: 16px 0 0 16px;
    gap: 32px;
}

#ss-recent {
    display: flex;
    flex-direction: column;
    flex-wrap: wrap;
    height: 120px;
    column-gap: 32px;
}

#ss-org-list {
    padding: 16px 0 16px 0;
    margin: 16px 0 0 0;
    border-top: 1px solid #ECECEF;
}

#nav-switcher:hover {
    background-color: #ECECEF;
}

#ss-nav-switcher {
    display: flex;
    align-items: center;
    height: 40px;
    margin: 8px 4px 0 4px;
    padding: 0 12px 0 12px;
    border: 1px solid #ECECEF;
    border-bottom: 1px solid #ECECEF;
    background-color: #FBFAFD;
}

#switcher-info {
    display: flex;
    flex-grow: 1;
    justify-content: flex-start;
    align-items: center;
    gap: 8px;
    color: #333238;
    font-size: 14px;
    font-weight: 600;
}

#switcher-info img {
    height: 24px;
    width: 24px;
}

#ss-switcher-list {
    position: fixed;
    top: 92px;
    left: 8px;
    width: 512px;
    padding: 0 0 16px 0;
    border-radius: 4px;
    background-color: #FFFFFF;
    border: 1px solid #BFBFBF;
    box-shadow: 0 2px 2px rgba(0, 0, 0, .16);
    box-shadow: 0 2px 8px rgba(0, 0, 0, .16);
    z-index: 900;
    overflow: hidden;
}

#ss-outside {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    z-index: 800;
}

#ss-switcher-search {
    display: flex;
    justify-items: center;
    border-bottom: 1px solid #BFBFC3;
    padding: 0 0 0 8px;
}

#ss-switcher-search input {
    flex-grow: 1;
    border: none;
    height: 40px;
    padding: 0 0 0 8px;
    font-size: 12px;
    font-family: 'Inter', sans-serif;
}

#switcher-slide #switchto {
    padding: 16px 0 8px 16px;
}

#switchto-label {
    font-size: 14px;
    font-weight: bold;
    margin: 0 0 8px 12px;
}

.switchto-item {
    display: flex;
    align-items: center;
    gap: 8px;
    height: 32px;
    padding: 0 0 0 12px;
    font-size: 14px;
    line-height: 16px;
}

.switchto-item:hover {
    background-color: #ECECEF;
}

.switchsection {
    font-size: 10px;
    font-weight: 400px;
    color: #737278;
    border-top: 1px solid #ECECEF;
    padding: 16px 0 16px 4px;
    margin: 0 8px 0 8px;
}

.switchsection-label {
    font-size: 10px;
    font-weight: 400px;
    color: #737278;
    margin: 0 0 8px 0;
}
</style>